#ifndef __FPS_H__
#define __FPS_H__

#include "../varglob.h"

typedef struct FPSManager {
     int now;
	 int last; 
	 int framerate;
	 int limitbegin;
	 int limitdelay;
}
FPSManager;

void initFPS(FPSManager*fps);
float getFPS(FPSManager*fps);
int UpdateFPS(FPSManager*fps);
int delayFPS(FPSManager*fps, float delay);

#endif
