#include "Frustum.h"

void updateExtractPlaneFrustum(Frustum*frustum) {
     glGetFloatv(GL_MODELVIEW_MATRIX, frustum->modelview);//on rcupre la matrice de modlisation
	 glGetFloatv(GL_PROJECTION_MATRIX, frustum->projection);//on rcupre la matrice de projection
	 
	 frustum->clipping[0] = frustum->modelview[0]*frustum->projection[0]+frustum->modelview[1]*frustum->projection[4]+frustum->modelview[2]*frustum->projection[8]+frustum->modelview[3]*frustum->projection[12];
	 frustum->clipping[1] = frustum->modelview[0]*frustum->projection[1]+frustum->modelview[1]*frustum->projection[5]+frustum->modelview[2]*frustum->projection[9]+frustum->modelview[3]*frustum->projection[13];
	 frustum->clipping[2] = frustum->modelview[0]*frustum->projection[2]+frustum->modelview[1]*frustum->projection[6]+frustum->modelview[2]*frustum->projection[10]+frustum->modelview[3]*frustum->projection[14];
	 frustum->clipping[3] = frustum->modelview[0]*frustum->projection[3]+frustum->modelview[1]*frustum->projection[7]+frustum->modelview[2]*frustum->projection[11]+frustum->modelview[3]*frustum->projection[15];
	 
	 frustum->clipping[4] = frustum->modelview[4]*frustum->projection[0]+frustum->modelview[5]*frustum->projection[4]+frustum->modelview[6]*frustum->projection[8]+frustum->modelview[7]*frustum->projection[12];
	 frustum->clipping[5] = frustum->modelview[4]*frustum->projection[1]+frustum->modelview[5]*frustum->projection[5]+frustum->modelview[6]*frustum->projection[9]+frustum->modelview[7]*frustum->projection[13];
	 frustum->clipping[6] = frustum->modelview[4]*frustum->projection[2]+frustum->modelview[5]*frustum->projection[6]+frustum->modelview[6]*frustum->projection[10]+frustum->modelview[7]*frustum->projection[14];
	 frustum->clipping[7] = frustum->modelview[4]*frustum->projection[3]+frustum->modelview[5]*frustum->projection[7]+frustum->modelview[6]*frustum->projection[11]+frustum->modelview[7]*frustum->projection[15];	
	 
	 frustum->clipping[4] = frustum->modelview[4]*frustum->projection[0]+frustum->modelview[5]*frustum->projection[4]+frustum->modelview[6]*frustum->projection[8]+frustum->modelview[7]*frustum->projection[12];
	 frustum->clipping[5] = frustum->modelview[4]*frustum->projection[1]+frustum->modelview[5]*frustum->projection[5]+frustum->modelview[6]*frustum->projection[9]+frustum->modelview[7]*frustum->projection[13];
	 frustum->clipping[6] = frustum->modelview[4]*frustum->projection[2]+frustum->modelview[5]*frustum->projection[6]+frustum->modelview[6]*frustum->projection[10]+frustum->modelview[7]*frustum->projection[14];
	 frustum->clipping[7] = frustum->modelview[4]*frustum->projection[3]+frustum->modelview[5]*frustum->projection[7]+frustum->modelview[6]*frustum->projection[11]+frustum->modelview[7]*frustum->projection[15];	 
	 
	 frustum->clipping[8] = frustum->modelview[8]*frustum->projection[0]+frustum->modelview[9]*frustum->projection[4]+frustum->modelview[10]*frustum->projection[8]+frustum->modelview[11]*frustum->projection[12];
	 frustum->clipping[9] = frustum->modelview[8]*frustum->projection[1]+frustum->modelview[9]*frustum->projection[5]+frustum->modelview[10]*frustum->projection[9]+frustum->modelview[11]*frustum->projection[13];
	 frustum->clipping[10] = frustum->modelview[8]*frustum->projection[2]+frustum->modelview[9]*frustum->projection[6]+frustum->modelview[10]*frustum->projection[10]+frustum->modelview[11]*frustum->projection[14];
	 frustum->clipping[11] = frustum->modelview[8]*frustum->projection[3]+frustum->modelview[9]*frustum->projection[7]+frustum->modelview[10]*frustum->projection[11]+frustum->modelview[11]*frustum->projection[15];
	 
	 frustum->clipping[12] = frustum->modelview[12]*frustum->projection[0]+frustum->modelview[13]*frustum->projection[4]+frustum->modelview[14]*frustum->projection[8]+frustum->modelview[15]*frustum->projection[12];
	 frustum->clipping[13] = frustum->modelview[12]*frustum->projection[1]+frustum->modelview[13]*frustum->projection[5]+frustum->modelview[14]*frustum->projection[9]+frustum->modelview[15]*frustum->projection[13];
	 frustum->clipping[14] = frustum->modelview[12]*frustum->projection[2]+frustum->modelview[13]*frustum->projection[6]+frustum->modelview[14]*frustum->projection[10]+frustum->modelview[15]*frustum->projection[14];
	 frustum->clipping[15] = frustum->modelview[12]*frustum->projection[3]+frustum->modelview[13]*frustum->projection[7]+frustum->modelview[14]*frustum->projection[11]+frustum->modelview[15]*frustum->projection[15];	 
	 
	 //on extrait le plan de droite:
	 frustum->frustum[0][0] = frustum->clipping[3]-frustum->clipping[0];
	 frustum->frustum[0][1] = frustum->clipping[7]-frustum->clipping[4];
	 frustum->frustum[0][2] = frustum->clipping[11]-frustum->clipping[8];
	 frustum->frustum[0][3] = frustum->clipping[15]-frustum->clipping[12];
	 
	 //on normalise:
	 frustum->normalisation = sqrt(frustum->frustum[0][0]*frustum->frustum[0][0]+frustum->frustum[0][1]*frustum->frustum[0][1]+frustum->frustum[0][2]*frustum->frustum[0][2]+frustum->frustum[0][3]*frustum->frustum[0][3]);
	 frustum->frustum[0][0] = frustum->frustum[0][0]/frustum->normalisation;
	 frustum->frustum[0][1] = frustum->frustum[0][1]/frustum->normalisation;
	 frustum->frustum[0][2] = frustum->frustum[0][2]/frustum->normalisation;
	 frustum->frustum[0][3] = frustum->frustum[0][3]/frustum->normalisation;
	 
	 //on extrait le plan de gauche:
	 frustum->frustum[1][0] = frustum->clipping[3]+frustum->clipping[0];
	 frustum->frustum[1][1] = frustum->clipping[7]+frustum->clipping[4];
	 frustum->frustum[1][2] = frustum->clipping[11]+frustum->clipping[8];
	 frustum->frustum[1][3] = frustum->clipping[15]+frustum->clipping[12];
	 
	 //on normalise:
	 frustum->normalisation = sqrt(frustum->frustum[1][0]*frustum->frustum[1][0]+frustum->frustum[1][1]*frustum->frustum[1][1]+frustum->frustum[1][2]*frustum->frustum[1][2]+frustum->frustum[1][3]*frustum->frustum[1][3]);
	 frustum->frustum[1][0] = frustum->frustum[1][0]/frustum->normalisation;
	 frustum->frustum[1][1] = frustum->frustum[1][1]/frustum->normalisation;
	 frustum->frustum[1][2] = frustum->frustum[1][2]/frustum->normalisation;
	 frustum->frustum[1][3] = frustum->frustum[1][3]/frustum->normalisation;
	 
	 //on extrait le plan du bas:
	 frustum->frustum[2][0] = frustum->clipping[3]+frustum->clipping[1];
	 frustum->frustum[2][1] = frustum->clipping[7]+frustum->clipping[5];
	 frustum->frustum[2][2] = frustum->clipping[11]+frustum->clipping[9];
	 frustum->frustum[2][3] = frustum->clipping[15]+frustum->clipping[13];
	 
	 //on normalise:
	 frustum->normalisation = sqrt(frustum->frustum[2][0]*frustum->frustum[2][0]+frustum->frustum[2][1]*frustum->frustum[2][1]+frustum->frustum[2][2]*frustum->frustum[2][2]+frustum->frustum[2][3]*frustum->frustum[2][3]);
	 frustum->frustum[2][0] = frustum->frustum[2][0]/frustum->normalisation;
	 frustum->frustum[2][1] = frustum->frustum[2][1]/frustum->normalisation;
	 frustum->frustum[2][2] = frustum->frustum[2][2]/frustum->normalisation;
	 frustum->frustum[2][3] = frustum->frustum[2][3]/frustum->normalisation;
	 
	 //on extrait le plan du haut:
	 frustum->frustum[3][0] = frustum->clipping[3]-frustum->clipping[1];
	 frustum->frustum[3][1] = frustum->clipping[7]-frustum->clipping[5];
	 frustum->frustum[3][2] = frustum->clipping[11]-frustum->clipping[9];
	 frustum->frustum[3][3] = frustum->clipping[15]-frustum->clipping[13];
	 
	 //on normalise:
	 frustum->normalisation = sqrt(frustum->frustum[3][0]*frustum->frustum[3][0]+frustum->frustum[3][1]*frustum->frustum[3][1]+frustum->frustum[3][2]*frustum->frustum[3][2]+frustum->frustum[3][3]*frustum->frustum[3][3]);
	 frustum->frustum[3][0] = frustum->frustum[3][0]/frustum->normalisation;
	 frustum->frustum[3][1] = frustum->frustum[3][1]/frustum->normalisation;
	 frustum->frustum[3][2] = frustum->frustum[3][2]/frustum->normalisation;
	 frustum->frustum[3][3] = frustum->frustum[3][3]/frustum->normalisation;
	 
	 //on extrait le plan loign:
	 frustum->frustum[4][0] = frustum->clipping[3]-frustum->clipping[2];
	 frustum->frustum[4][1] = frustum->clipping[7]-frustum->clipping[6];
	 frustum->frustum[4][2] = frustum->clipping[11]-frustum->clipping[10];
	 frustum->frustum[4][3] = frustum->clipping[15]-frustum->clipping[14];
	 
	 //on normalise:
	 frustum->normalisation = sqrt(frustum->frustum[4][0]*frustum->frustum[4][0]+frustum->frustum[4][1]*frustum->frustum[4][1]+frustum->frustum[4][2]*frustum->frustum[4][2]+frustum->frustum[4][13]*frustum->frustum[4][3]);
	 frustum->frustum[4][0] = frustum->frustum[4][0]/frustum->normalisation;
	 frustum->frustum[4][1] = frustum->frustum[4][1]/frustum->normalisation;
	 frustum->frustum[4][2] = frustum->frustum[4][2]/frustum->normalisation;
	 frustum->frustum[4][3] = frustum->frustum[4][3]/frustum->normalisation;
	 
	 //on extrait le plan proche:
	 frustum->frustum[5][0] = frustum->clipping[3]+frustum->clipping[2];
	 frustum->frustum[5][1] = frustum->clipping[7]+frustum->clipping[6];
	 frustum->frustum[5][2] = frustum->clipping[11]+frustum->clipping[10];
	 frustum->frustum[5][3] = frustum->clipping[15]+frustum->clipping[14];
	 
	 //on normalise:
	 frustum->normalisation = sqrt(frustum->frustum[5][0]*frustum->frustum[5][0]+frustum->frustum[5][1]*frustum->frustum[5][1]+frustum->frustum[5][2]*frustum->frustum[5][2]+frustum->frustum[5][13]*frustum->frustum[5][3]);
	 frustum->frustum[5][0] = frustum->frustum[5][0]/frustum->normalisation;
	 frustum->frustum[5][1] = frustum->frustum[5][1]/frustum->normalisation;
	 frustum->frustum[5][2] = frustum->frustum[5][2]/frustum->normalisation;
	 frustum->frustum[5][3] = frustum->frustum[5][3]/frustum->normalisation;	 
}

int pointInFrustum(float x, float y, float z, Frustum*frustum) {
     int distance;
	 for(frustum->plane=0; frustum->plane<6; frustum->plane++) {//afin de vrifier tous les plans :)
	     //distance = A*x+B*y+C*z+D//pour connaitre si notre point est dans le frustum ou non :p
	     distance = frustum->frustum[frustum->plane][0]*x+frustum->frustum[frustum->plane][1]*y+frustum->frustum[frustum->plane][2]*z+frustum->frustum[frustum->plane][3];
		 if(distance <= 0) {//si le point n'est pas dans le champs de vision
		     return 0;
		 }
		 else return 1;//le point est dans le frustum
	 }
}

int sphereInFrustum(float x, float y, float z, float rayon, Frustum*frustum) {//pour un cercle de rayon rayon et de centre (x, y, z) comme coordonnes :)
     int distance;
	 int face;
	 for(frustum->plane=0; frustum->plane<6; frustum->plane++) {
	     face = 0;//pour dterminer le nombre de plan visibles
		 distance = frustum->frustum[frustum->plane][0]*x+frustum->frustum[frustum->plane][1]*y+frustum->frustum[frustum->plane][2]*z+frustum->frustum[frustum->plane][3];//c'est la distance du point :)
		 
		 if(distance <= -rayon) {//le cercle n'est pas dans le champs de vision :p
		     return 0;
		 }
		 else if(distance > rayon) {//le cercle est visible totalement 
		     return 1;
		 }
		 else if(distance > -rayon && distance <= rayon) {//le cercle est visible partiellement
		     return 2;
		 }
	 }
}
     
int cubeInFrustum(float x, float y, float z, float size, Frustum*frustum) {//on teste les 8 points consttuant le carr et pour chaque on va tester si le point est totalement dans le Frustum, partiellement ou pas du tout :)
     int face;
	 for(frustum->plane=0; frustum->plane<6; frustum->plane++) {
	     face = 0;
		 if(frustum->frustum[frustum->plane][0]*(x-size)+frustum->frustum[frustum->plane][1]*(y-size)+frustum->frustum[frustum->plane][2]*(z-size)+frustum->frustum[frustum->plane][3] > 0) {
		     face++;
		 }
	     if(frustum->frustum[frustum->plane][0]*(x+size)+frustum->frustum[frustum->plane][1]*(y-size)+frustum->frustum[frustum->plane][2]*(z-size)+frustum->frustum[frustum->plane][3] > 0) {
		     face++;
		 }
		 if(frustum->frustum[frustum->plane][0]*(x+size)+frustum->frustum[frustum->plane][1]*(y-size)+frustum->frustum[frustum->plane][2]*(z+size)+frustum->frustum[frustum->plane][3] > 0) {
		     face++;
		 }
		 if(frustum->frustum[frustum->plane][0]*(x-size)+frustum->frustum[frustum->plane][1]*(y-size)+frustum->frustum[frustum->plane][2]*(z+size)+frustum->frustum[frustum->plane][3] > 0) {
		     face++;
		 }	
	     if(frustum->frustum[frustum->plane][0]*(x-size)+frustum->frustum[frustum->plane][1]*(y+size)+frustum->frustum[frustum->plane][2]*(z-size)+frustum->frustum[frustum->plane][3] > 0) {
		     face++;
		 }
	     if(frustum->frustum[frustum->plane][0]*(x+size)+frustum->frustum[frustum->plane][1]*(y+size)+frustum->frustum[frustum->plane][2]*(z-size)+frustum->frustum[frustum->plane][3] > 0) {
		     face++;
		 }
		 if(frustum->frustum[frustum->plane][0]*(x+size)+frustum->frustum[frustum->plane][1]*(y+size)+frustum->frustum[frustum->plane][2]*(z+size)+frustum->frustum[frustum->plane][3] > 0) {
		     face++;
		 }
		 if(frustum->frustum[frustum->plane][0]*(x-size)+frustum->frustum[frustum->plane][1]*(y+size)+frustum->frustum[frustum->plane][2]*(z+size)+frustum->frustum[frustum->plane][3] > 0) {
		     face++;
		 }
		 if(face == 8) return 1;//les 8 points du cube sont dans le volume d'affichage
		 else if(face > 0 && face < 8) return 2;//certains points du cube sont en dehors du volume d'affichage
		 else if(face == 0) return 0;//les 8 points du cube sont en dehors du volume d'affichage
	 }
}
