#include "OBJLoader.h"

int readOBJ(ModelObj*modelobj, char*filename, int modeloadobj) {
      
	 FILE*obj = NULL;
      
	 modelobj->linereadvertex = 1;
	 modelobj->linereadtexcoord = 1;
	 modelobj->linereadordervtex = 1;
	 modelobj->linereadusemtl = 1;
      
	 obj = fopen(filename, "r");
      
	 static char character[100];
	 if(obj > 0) {
	     while(fgets(character, sizeof(character), obj) > 0) {
			 if(character[0] == 'u' && character[1] == 's' && character[2] == 'e' && character[3] == 'm' && character[4] == 't' && character[5] == 'l') {
				 modelobj->linereadusemtl++;
			 }
		     if(modeloadobj == 0) {//mode du fichier .obj "normal"   lire c'est--dire dpourvu de coordonnes de texture
	             if(character[0] == 'v') {
			         modelobj->linereadvertex++;
		         }
		         else if(character[0] == 'f') {
			         modelobj->linereadordervtex++;
		         }
			 }
		     else if(modeloadobj == 1) {//mode du fichier .obj "pluspouss"  lire c'est--dire avec les coordonnes de texture
	             if((character[0] == 'v') && (character[1] != 't')) {
			         modelobj->linereadvertex++;
		         }
			     else if((character[0] == 'v') && (character[1] == 't')) {
				     modelobj->linereadtexcoord++;
			     }
		         else if(character[0] == 'f') {
			         modelobj->linereadordervtex++;
		         }
			 }
	     }
	 }
	 else return 0;
	 fclose(obj);
	 return 1;
}

int loadOBJ(ModelObj*modelobj, char*filename, int modeloadobj) {
      
	 readOBJ(&(*modelobj), filename, modeloadobj);
      
	 FILE*obj = NULL;
	 obj = fopen(filename, "r");
       
	 modelobj->vertex = (Vertexs*)malloc(sizeof(Vertexs)*modelobj->linereadvertex+1);//on ajoute 1 pour la scurit de notre tableau (au cas o si dpassement de mmoire
	 modelobj->texcoord = (Texcoords*)malloc(sizeof(Texcoords)*modelobj->linereadtexcoord+1);
	 modelobj->ordervertex = (orderVertexs*)malloc(sizeof(orderVertexs)*modelobj->linereadordervtex+1);
	 modelobj->ordertexcoord = (orderTexcoords*)malloc(sizeof(orderTexcoords)*modelobj->linereadordervtex+1);
	 modelobj->usemtl = (int*)malloc(sizeof(int)*modelobj->linereadusemtl);
	 modelobj->usemtltexture = (int*)malloc(sizeof(int)*modelobj->linereadusemtl);
           
	 if(modelobj->vertex == NULL) return 0;
	 if(modelobj->texcoord == NULL) return 0;
	 if(modelobj->ordervertex == NULL) return 0;
	 if(modelobj->ordertexcoord == NULL) return 0;
	 if(modelobj->usemtl == NULL) return 0;
	 if(modelobj->usemtltexture == NULL) return 0;
          
	 modelobj->lineobjvertex = 1;
	 modelobj->lineobjtexcoord = 1;
	 modelobj->lineobjordervtex = 1;
	 modelobj->lineobjusemtl = 0;
	 modelobj->lineobjusemtltexture = 0;
      
	 modelobj->fordepart = 1;//correspond  la valeur que l'on va mettre au dbut de la boucle for (exemple : for(i=modelobj->fordepart...
     
	 static char character[100];
	 if(obj > 0) {
	     while(fgets(character, sizeof(character), obj) > 0) {
		     if(character[0] == 'u' && character[1] == 's' && character[2] == 'e' && character[3] == 'm' && character[4] == 't' && character[5] == 'l') {
				 modelobj->lineobjusemtl++;
				 modelobj->lineobjusemtltexture++;
				 modelobj->usemtl[modelobj->lineobjusemtl] = modelobj->lineobjordervtex;//-1 car c'est pour retourner la bonne valeur de modelobj->lineobjordervtex sinon sans le -1 cela renvoie la premire valeur de modelobj->lineobjordervtex de usemtl suivant :) // seulement pour la version pc pour la version psp on ne mets pas -1 car je pense que le temps d'excution de l'action est plus lent pour le processeur de la PSP donc il n'a pas le temps d'avoir pris en compte le modelobj->lineobjordervtex en trop ;)
				 sscanf(character+7, "%d", &modelobj->usemtltexture[modelobj->lineobjusemtltexture]);
			 }
			 if(modeloadobj == 0) {//mode du fichier .obj "normal"  charger c'est--dire dpourvu de coordonnes de texture
	             if(character[0] == 'v') {
		             sscanf(character+2, "%f %f %f", &modelobj->vertex[modelobj->lineobjvertex].x, &modelobj->vertex[modelobj->lineobjvertex].y, &modelobj->vertex[modelobj->lineobjvertex].z);
			         modelobj->lineobjvertex++;
		         }
		         else if(character[0] == 'f') {
		             sscanf(character+2, "%d %d %d", &modelobj->ordervertex[modelobj->lineobjordervtex].v1, &modelobj->ordervertex[modelobj->lineobjordervtex].v2, &modelobj->ordervertex[modelobj->lineobjordervtex].v3);//ne pas utiliser modelobj.ordervertex[lineobjordervtex].v4 si au niveau de 'f' que 3 valeurs (sinon freeeze de la PSP) mais le remplacer par (dans la fonction d'affichage) glVertex3f(0.0f, 0.0f, 0.0f); pour ne pas laisser de vide ;)
			         modelobj->lineobjordervtex++;
		         }
			 }
		     else if(modeloadobj == 1) {//mode du fichier .obj "pluspouss"  charger c'est--dire avec les coordonnes de texture
	             if((character[0] == 'v') && (character[1] != 't')) {
		             sscanf(character+2, "%f %f %f", &modelobj->vertex[modelobj->lineobjvertex].x, &modelobj->vertex[modelobj->lineobjvertex].y, &modelobj->vertex[modelobj->lineobjvertex].z);
			         modelobj->lineobjvertex++;
		         }
			     else if((character[0] == 'v') && (character[1] == 't')) {
			         sscanf(character+3, "%f %f", &modelobj->texcoord[modelobj->lineobjtexcoord].x, &modelobj->texcoord[modelobj->lineobjtexcoord].y);
				     modelobj->lineobjtexcoord++;
			     }
		         else if(character[0] == 'f') {
		             sscanf(character+2, "%d/%d %d/%d %d/%d", &modelobj->ordervertex[modelobj->lineobjordervtex].v1, &modelobj->ordertexcoord[modelobj->lineobjordervtex].t1, &modelobj->ordervertex[modelobj->lineobjordervtex].v2, &modelobj->ordertexcoord[modelobj->lineobjordervtex].t2, &modelobj->ordervertex[modelobj->lineobjordervtex].v3, &modelobj->ordertexcoord[modelobj->lineobjordervtex].t3);
			         modelobj->lineobjordervtex++;
		         }
			 }
	     }
	     modelobj->lineobjusemtl++;
		 modelobj->usemtl[modelobj->lineobjusemtl] = modelobj->lineobjordervtex-1;
	 }
	 else return 0;
	 fclose(obj);
	 return 1;
}

void OBJDisplay(ModelObj*obj, int texture) {
     int i;
	 if(texture != 0) glBindTexture(GL_TEXTURE_2D, texture);
	 glBegin(GL_TRIANGLES);
	 for(i=obj->fordepart; i<obj->linereadordervtex; i++) {
	     if(texture != 0) {
		     glTexCoord2f(obj->texcoord[obj->ordertexcoord[i].t1].x, obj->texcoord[obj->ordertexcoord[i].t1].y); glVertex3f(obj->vertex[obj->ordervertex[i].v1].x, obj->vertex[obj->ordervertex[i].v1].y, obj->vertex[obj->ordervertex[i].v1].z);
		     glTexCoord2f(obj->texcoord[obj->ordertexcoord[i].t2].x, obj->texcoord[obj->ordertexcoord[i].t2].y); glVertex3f(obj->vertex[obj->ordervertex[i].v2].x, obj->vertex[obj->ordervertex[i].v2].y, obj->vertex[obj->ordervertex[i].v2].z);
		     glTexCoord2f(obj->texcoord[obj->ordertexcoord[i].t3].x, obj->texcoord[obj->ordertexcoord[i].t3].y); glVertex3f(obj->vertex[obj->ordervertex[i].v3].x, obj->vertex[obj->ordervertex[i].v3].y, obj->vertex[obj->ordervertex[i].v3].z);
		 }
		 else if(texture == 0) {
		     glVertex3f(obj->vertex[obj->ordervertex[i].v1].x, obj->vertex[obj->ordervertex[i].v1].y, obj->vertex[obj->ordervertex[i].v1].z);
		     glVertex3f(obj->vertex[obj->ordervertex[i].v2].x, obj->vertex[obj->ordervertex[i].v2].y, obj->vertex[obj->ordervertex[i].v2].z);
		     glVertex3f(obj->vertex[obj->ordervertex[i].v3].x, obj->vertex[obj->ordervertex[i].v3].y, obj->vertex[obj->ordervertex[i].v3].z);
		 }
	 }
	 glEnd();
}

void freeOBJ(ModelObj*obj) {
     free(obj->vertex);
	 free(obj->ordervertex);
	 free(obj->texcoord);
	 free(obj->ordertexcoord);
	 free(obj->usemtl);
	 free(obj->usemtltexture);
}
