#include "Particule.h"

void initParticule(nameParticule*name, int maxparticule, float x, float y, float z, int mode2D, float divspeed, float divactive, float divsize) {
     int i;
	 for(i=0; i<maxparticule; i++) {
	     name->particule[i].anglex = ((rand()%(360+360)-360)*M_PI)/180.0f;
		 name->particule[i].angley = ((rand()%(360+360)-360)*M_PI)/180.0f;
		 name->particule[i].anglez = ((rand()%(360+360)-360)*M_PI)/180.0f;
		 name->particule[i].x = x;
		 name->particule[i].y = y;
		 if(!mode2D) name->particule[i].z = z;
		 name->particule[i].oldx = name->particule[i].x;
		 name->particule[i].oldy = name->particule[i].y;
		 if(!mode2D) name->particule[i].oldz = name->particule[i].z;
		 name->particule[i].r = rand()%(100-0)+0;
		 name->particule[i].r /= 100.0f;
		 name->particule[i].b = rand()%(100-0)+0;
		 name->particule[i].b /= 100.0f;
		 name->particule[i].g = rand()%(100-0)+0;
		 name->particule[i].g /= 100.0f;
		 name->particule[i].speed = rand()%(5-1)+1;
		 name->particule[i].speed /= divsize;
		 name->particule[i].delayactive = rand()%(50-5)+50;
		 name->particule[i].delayactive /= divactive;
		 name->particule[i].size = rand()%(10-1)+1;
		 name->particule[i].size /= divsize;
		 name->particule[i].active = 1.0f;
	 }
}

int displayParticule(nameParticule*name, int maxparticule, int mode2D, float divspeed, float divactive, float divsize, int modeTexture, int texture) {
     int i;
	 for(i=0; i<maxparticule; i++) {
	     if(name->particule[i].active >= 0.0f) {
		     if(!modeTexture) {
			     if(!mode2D) {
			         name->particule[i].x+=name->particule[i].anglex*name->particule[i].speed;
			         name->particule[i].y+=name->particule[i].angley*name->particule[i].speed;
			         name->particule[i].z+=name->particule[i].anglez*name->particule[i].speed;
			         
			         glColor4f(name->particule[i].r, name->particule[i].g, name->particule[i].b, name->particule[i].active);
			         
			         glBegin(GL_TRIANGLE_STRIP);
			         glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glEnd();
			         
			         /*glBegin(GL_TRIANGLE_STRIP);
			         glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glEnd();
			         
			         glBegin(GL_TRIANGLE_STRIP);
			         glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glEnd();
			         
			         glBegin(GL_TRIANGLE_STRIP);
			         glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glEnd();*/
					 
			         glBegin(GL_TRIANGLE_STRIP);
			         glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y+(name->particule[i].size/2.0f), name->particule[i].z-name->particule[i].size);
			         glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y+(name->particule[i].size/2.0f), name->particule[i].z+name->particule[i].size);
			         glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y+(name->particule[i].size/2.0f), name->particule[i].z-name->particule[i].size);
			         glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y+(name->particule[i].size/2.0f), name->particule[i].z+name->particule[i].size);
			         glEnd();					 
			         
			         name->particule[i].active-=name->particule[i].delayactive;
			     }
			     else if(mode2D > 0) {
			         name->particule[i].x+=name->particule[i].anglex*name->particule[i].speed;
			         name->particule[i].y+=name->particule[i].angley*name->particule[i].speed;
			         //name->particule[i].z+=name->particule[i].anglez*name->particule[i].speed;			     
				     
				     glColor4f(name->particule[i].r, name->particule[i].g, name->particule[i].b, name->particule[i].active);
				     
				     glBegin(GL_TRIANGLE_STRIP);
				     glVertex2f(name->particule[i].x-name->particule[i].size, name->particule[i].y-name->particule[i].size);
				     glVertex2f(name->particule[i].x-name->particule[i].size, name->particule[i].y+name->particule[i].size);
				     glVertex2f(name->particule[i].x+name->particule[i].size, name->particule[i].y-name->particule[i].size);
				     glVertex2f(name->particule[i].x+name->particule[i].size, name->particule[i].y+name->particule[i].size);
				     glEnd();
				     
				     name->particule[i].active-=name->particule[i].delayactive;
			     }
			 }
			 else if(modeTexture > 0) {
			     if(!mode2D) {
			         name->particule[i].x+=name->particule[i].anglex*name->particule[i].speed;
			         name->particule[i].y+=name->particule[i].angley*name->particule[i].speed;
			         name->particule[i].z+=name->particule[i].anglez*name->particule[i].speed;
			         
			         glColor3f(1.0f, 1.0f, 1.0f);//on nettoie les couleurs avant d'appliquer la texture pour viter les couleurs bizarres sur la texture :)
			         glEnable(GL_TEXTURE_2D);
					 glEnable(GL_ALPHA_TEST);
					 glAlphaFunc(GL_GREATER, 0.1f);
			         glBindTexture(GL_TEXTURE_2D, texture);
			         //glColor4f(name->particule[i].r, name->particule[i].g, name->particule[i].b, name->particule[i].active);
			         
			         glBegin(GL_TRIANGLE_STRIP);
			         glTexCoord2f(0.0f, 0.0f); glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glTexCoord2f(0.0f, 1.0f); glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glTexCoord2f(1.0f, 0.0f); glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glTexCoord2f(1.0f, 1.0f); glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glEnd();
			         
			         /*glBegin(GL_TRIANGLE_STRIP);
			         glTexCoord2f(0.0f, 0.0f); glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glTexCoord2f(0.0f, 1.0f); glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glTexCoord2f(1.0f, 0.0f); glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glTexCoord2f(1.0f, 1.0f); glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glEnd();
			         
					 glBegin(GL_TRIANGLE_STRIP);
			         glTexCoord2f(0.0f, 0.0f); glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glTexCoord2f(0.0f, 1.0f); glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glTexCoord2f(1.0f, 0.0f); glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glTexCoord2f(1.0f, 1.0f); glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y-name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glEnd();
					 
			         glBegin(GL_TRIANGLE_STRIP);
			         glTexCoord2f(0.0f, 0.0f); glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glTexCoord2f(0.0f, 1.0f); glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glTexCoord2f(1.0f, 0.0f); glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z-name->particule[i].size);
			         glTexCoord2f(1.0f, 1.0f); glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y+name->particule[i].size, name->particule[i].z+name->particule[i].size);
			         glEnd();*/
					 
			         glBegin(GL_TRIANGLE_STRIP);
			         glTexCoord2f(0.0f, 0.0f); glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y+(name->particule[i].size/2.0f), name->particule[i].z-name->particule[i].size);
			         glTexCoord2f(0.0f, 1.0f); glVertex3f(name->particule[i].x-name->particule[i].size, name->particule[i].y+(name->particule[i].size/2.0f), name->particule[i].z+name->particule[i].size);
			         glTexCoord2f(1.0f, 0.0f); glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y+(name->particule[i].size/2.0f), name->particule[i].z-name->particule[i].size);
			         glTexCoord2f(1.0f, 1.0f); glVertex3f(name->particule[i].x+name->particule[i].size, name->particule[i].y+(name->particule[i].size/2.0f), name->particule[i].z+name->particule[i].size);
			         glEnd();
			         
			         name->particule[i].active-=name->particule[i].delayactive;
			         
			         glDisable(GL_TEXTURE_2D);
					 glDisable(GL_ALPHA_TEST);
			     }
			     else if(mode2D > 0) {
			         name->particule[i].x+=name->particule[i].anglex*name->particule[i].speed;
			         name->particule[i].y+=name->particule[i].angley*name->particule[i].speed;
			         //name->particule[i].z+=name->particule[i].anglez*name->particule[i].speed;			     
				     
				     //glColor4f(name->particule[i].r, name->particule[i].g, name->particule[i].b, name->particule[i].active);
				     glColor3f(1.0f, 1.0f, 1.0f);
				     glEnable(GL_TEXTURE_2D);
					 glEnable(GL_ALPHA_TEST);
					 glAlphaFunc(GL_GREATER, 0.1f);					 
			         glBindTexture(GL_TEXTURE_2D, texture);
				     
				     glBegin(GL_TRIANGLE_STRIP);
				     glTexCoord2f(0.0f, 0.0f); glVertex2f(name->particule[i].x-name->particule[i].size, name->particule[i].y-name->particule[i].size);
				     glTexCoord2f(0.0f, 1.0f); glVertex2f(name->particule[i].x-name->particule[i].size, name->particule[i].y+name->particule[i].size);
				     glTexCoord2f(1.0f, 0.0f); glVertex2f(name->particule[i].x+name->particule[i].size, name->particule[i].y-name->particule[i].size);
				     glTexCoord2f(1.0f, 1.0f); glVertex2f(name->particule[i].x+name->particule[i].size, name->particule[i].y+name->particule[i].size);
				     glEnd();
				     
				     name->particule[i].active-=name->particule[i].delayactive;
				     
				     glDisable(GL_TEXTURE_2D);
					 glDisable(GL_ALPHA_TEST);
			     }
			 }
		 }
		 else if(name->particule[i].active < 0.0f) {
	         name->particule[i].anglex = ((rand()%(360+360)-360)*M_PI)/180.0f;
		     name->particule[i].angley = ((rand()%(360+360)-360)*M_PI)/180.0f;
		     name->particule[i].anglez = ((rand()%(360+360)-360)*M_PI)/180.0f;
		     name->particule[i].x = name->particule[i].oldx;
		     name->particule[i].y = name->particule[i].oldy;
		     if(!mode2D) name->particule[i].z = name->particule[i].oldz;
		     name->particule[i].oldx = name->particule[i].x;
		     name->particule[i].oldy = name->particule[i].y;
		     if(!mode2D) name->particule[i].oldz = name->particule[i].z;
		     name->particule[i].r = rand()%(100-0)+0;
		     name->particule[i].r /= 100.0f;
		     name->particule[i].b = rand()%(100-0)+0;
		     name->particule[i].b /= 100.0f;
		     name->particule[i].g = rand()%(100-0)+0;
		     name->particule[i].g /= 100.0f;
		     name->particule[i].speed = rand()%(5-1)+1;
		     name->particule[i].speed /= divspeed;
		     name->particule[i].delayactive = rand()%(50-5)+50;
		     name->particule[i].delayactive /= divactive;
		     name->particule[i].size = rand()%(10-1)+1;
		     name->particule[i].size /= divsize;
		     name->particule[i].active = 1.0f;
		 }
	 }
}
