#include "Timer.h"

void timerInit(Timer*timer) {
     timer->countstart = 0;
	 timer->countpause = 0;
	 timer->oldcount = 0;	
	 timer->countpause = 0;
	 timer->count = 0;	 
	 timer->framerate = 0;
}

void timerStart(Timer*timer) {
	 timer->countstart = 1;
	 timer->countpause = 0;
	 timer->oldcount = 0;
	 timer->count = SDL_GetTicks();
}

void timerStop(Timer*timer) {
     timer->countstart = 0;
	 timer->countpause = 0;
	 timer->oldcount = 0;
	 timer->count = 0;
}

void timerPause(Timer*timer) {
     if(timer->countstart == 1 && timer->countpause == 0) {
	     timer->countpause = 1;
	 }
	 if(timer->countpause == 1) {
	     timer->oldcount = SDL_GetTicks()-timer->count;
	 }
}

void timerUnpause(Timer*timer) {
     if(timer->countpause == 1) {
	     timer->countpause = 0;
		 timer->count = SDL_GetTicks()-timer->oldcount;
		 timer->oldcount = 0;
	 }
}

int getTimer(Timer*timer) {
     if(timer->countstart == 1) {
		 if(timer->countpause == 0) {
	         return SDL_GetTicks()-timer->count;
	     }
	     else if(timer->countpause == 1) {
	         return timer->oldcount;
	     }
	 }
	 else return 0;
}

int istimerStart(Timer*timer) {
     return timer->countstart;
}

int istimerPause(Timer*timer) {
     return timer->countpause;
}
