#ifndef __TIMER_H__
#define __TIMER_H__

#include "../varglob.h"

typedef struct Timer {
     int count;
	 int countstart;
	 int countpause;
	 int oldcount;
	 int framerate;
}
Timer;

void timerInit(Timer*timer);
void timerStart(Timer*timer);
void timerStop(Timer*timer);
void timerPause(Timer*timer);
void timerUnpause(Timer*timer);
int getTimer(Timer*timer);
int istimerStart(Timer*timer);
int istimerPause(Timer*timer);

#endif
