#include <pspkernel.h>
#include <psploadexec.h>
#include <pspctrl.h>
#include <psploadexec_kernel.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <pspmoduleinfo.h>
#include <kubridge.h>
#include <systemctrl.h>
#include <pspkernel.h>
#include <pspctrl.h>
#include <psppower.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <psprtc.h>
#include <pspwlan.h>
#include <pspmscm.h>
#include <psptypes.h>
#include <pspiofilemgr.h>
#include <systemctrl_se.h>

PSP_MODULE_INFO("loadeboot", 0x1000, 1, 1);
PSP_MAIN_THREAD_ATTR(0);

//fonction permettant d'xcuter l'eboot pass en paramtre :)
int loadEboot(char*chemin) {
     
	 SceUID verification = sceIoOpen(chemin, PSP_O_RDONLY, 0777);
	 
     if(verification > 0) {
	 u8 vshmain_args[0x400];
	 struct SceKernelLoadExecVSHParam param;
	 memset(vshmain_args, 0, sizeof(vshmain_args));
	 
	 vshmain_args[0x40] = 1;
	 vshmain_args[0x280] = 1;
	 vshmain_args[0x284] = 3;
	 vshmain_args[0x286] = 5;
	 
	 memset(&param, 0, sizeof(param));
	 
	 param.size = sizeof(param);
	 param.args = strlen(chemin)+1;
	 param.argp = chemin;
	 param.key = "game";
	 param.vshmain_args_size = sizeof(vshmain_args);
	 param.vshmain_args = vshmain_args;
	 sctrlKernelLoadExecVSHMs2(chemin, &param);
	 sceIoClose(verification);
	 return 1;
	 }
	 else if(verification < 0) {
		 sceIoClose(verification);
	     return 0;
		 sceKernelExitGame();		 
	 }
}

int module_start(SceSize args, void *argp) {
	return 0;
}

int module_stop(SceSize args, void *argp) {
	return 0;
}
