#include "2D.h"

void glEnable2D(float width, float height, float cmin, float cmax) {
	 glMatrixMode(GL_PROJECTION);
	 glPushMatrix();//on fais des pile pour empcher que les autres matrix de visualisation des autres objet ne soit touch par les notres ici (sinon les autres objets 3D n'apparaissent pas) donc on fais une pile pour chaque matrice de visualisation ;)
	 glLoadIdentity();//on remplace la matrice courante par une matrice vierge de toutes transformation
	 glOrtho(0, width, height, 0, cmin, cmax);//pour permettre la visualisation en 2D par projection dite cavalire ;)
	 glMatrixMode(GL_MODELVIEW);
	 glPushMatrix();
	 glLoadIdentity();
}

void glDisable2D() {//on efface toutes les matrices courantes pour dsactiver la visualisation 2D
     glMatrixMode(GL_PROJECTION);
	 glPopMatrix();
	 glMatrixMode(GL_MODELVIEW);
	 glPopMatrix();
}
