#include "Font.h"

int resizeFont(int size) {
     int resize = 1;//resize == 1bit
	 while(resize < size) { 
	     resize<<=1;//on place tous les bit  gauche tant que resize est < size ;)
	 }
	 return resize;//on retoune sa valeur :)
}

int loadSDLFont(char*txt, char*filename, int taillepolice, SDL_Color color, float*w, float*h) {
     SDL_Surface*surface = NULL;
	 SDL_Surface*soclefont = NULL;
	 TTF_Font*police = NULL;
	 police = TTF_OpenFont(filename, taillepolice);
	 surface = TTF_RenderText_Blended(police, txt, color);
	 GLint font;
	 *w = surface->w;
	 *h = surface->h;
	 
	 if(surface > 0) {
	     soclefont = SDL_CreateRGBSurface(SDL_SWSURFACE, resizeFont(surface->w), resizeFont(surface->h), 32, surface->format->Rmask, surface->format->Gmask, surface->format->Bmask, surface->format->Amask);//on cre une surface 32 bits qui accueillera le texte
		 
		 SDL_BlitSurface(surface, NULL, soclefont, NULL);
		 
		 glGenTextures(1, &font);
		 glBindTexture(GL_TEXTURE_2D, font);
		 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		 glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, resizeFont(surface->w), resizeFont(surface->h), 0, GL_RGBA, GL_UNSIGNED_BYTE, soclefont->pixels);
	 }
	 else {
		 return 0;
	 }
	 SDL_FreeSurface(soclefont);
	 TTF_CloseFont(police);	 
	 return font;
}

void writeSDLFontLight(int font, float x, float y, float w, float h) {
		 //on place la texture "texte" opengl prcedemment convertie sur une surface plane de taille du texte 
		 glPushMatrix();
		 glEnable(GL_BLEND);
		 glBlendFunc(GL_ONE_MINUS_DST_ALPHA, GL_ONE);
		 glEnable(GL_TEXTURE_2D);
		 glBindTexture(GL_TEXTURE_2D, font);
		 glColor3f(1.0,1.0,1.0);
		 glBegin(GL_QUADS);
		 glTexCoord2f(1.0f, 1.0f); glVertex2f(x+resizeFont(w), y);
		 glTexCoord2f(0.0f, 1.0f); glVertex2f(x, y);		 
		 glTexCoord2f(0.0f, 0.0f); glVertex2f(x, y+resizeFont(h));
		 glTexCoord2f(1.0f, 0.0f); glVertex2f(x+resizeFont(w), y+resizeFont(h));
		 glEnd();
		 glDisable(GL_BLEND);
		 glPopMatrix();  
}	

void writeSDLFontFat(char*txt, char*filename, int taillepolice, SDL_Color color, float x, float y) {
	 SDL_Surface*surface = NULL;
	 TTF_Font*police = NULL;
	 police = TTF_OpenFont(filename, taillepolice);
	 SDL_Surface*soclefont = NULL;
	 surface = TTF_RenderText_Blended(police, txt, color);
	 GLint font;
	 
	 if(surface > 0) {
		 soclefont = SDL_CreateRGBSurface(SDL_SWSURFACE, resizeFont(surface->w), resizeFont(surface->h), 32, surface->format->Rmask, surface->format->Gmask, surface->format->Bmask, surface->format->Amask);//on cre une surface 32 bits qui accueillera le texte
		 
		 SDL_BlitSurface(surface, NULL, soclefont, NULL);
		 glGenTextures(1, &font);
		 glBindTexture(GL_TEXTURE_2D, font);
		 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		 glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, resizeFont(surface->w), resizeFont(surface->h), 0, GL_RGBA, GL_UNSIGNED_BYTE, soclefont->pixels);
		 //on place la texture "texte" opengl prcedemment convertie sur une surface plane de taille du texte 
		 glPushMatrix();
		 glEnable(GL_BLEND);
		 glBlendFunc(GL_ONE_MINUS_DST_ALPHA, GL_ONE);
		 glEnable(GL_TEXTURE_2D);
		 glBindTexture(GL_TEXTURE_2D, font);
		 glColor3f(1.0,1.0,1.0);
		 glBegin(GL_QUADS);
		 glTexCoord2f(1.0f, 1.0f); glVertex2f(x+resizeFont(surface->w), y);
		 glTexCoord2f(0.0f, 1.0f); glVertex2f(x, y);		 
		 glTexCoord2f(0.0f, 0.0f); glVertex2f(x, y+resizeFont(surface->h));
		 glTexCoord2f(1.0f, 0.0f); glVertex2f(x+resizeFont(surface->w), y+resizeFont(surface->h));
		 glEnd();
		 glDisable(GL_BLEND);
		 glPopMatrix();
	 }
	 else {
		 return;
	 }
	 TTF_CloseFont(police);	 
	 SDL_FreeSurface(soclefont);
	 SDL_FreeSurface(surface);
}	 

void writeSDLImageChar(char character, float taillefont, float x, float y) {
     float texturex;
	 float texturey;
	 if(character >= ' ' && character < '0') {
	     character-=' ';
		 texturex = (1.0f/16.0f)*character;
		 texturey = (1.0f/16.0f)*2;
	 }
	 else if(character >= '0' && character < '@') {
	     character-='0';
		 texturex = (1.0f/16.0f)*character;
		 texturey = (1.0f/16.0f)*3;
	 }
	 else if(character >= '@' && character < 'P') {
	     character-='@';
		 texturex = (1.0f/16.0f)*character;
		 texturey = (1.0f/16.0f)*4;
	 }
	 else if(character >= 'P' && character < '`') {
	     character-='P';
		 texturex = (1.0f/16.0f)*character;
		 texturey = (1.0f/16.0f)*5;
	 }
	 else if(character >= '`' && character < 'p') {
	     character-='`';
		 texturex = (1.0f/16.0f)*character;
		 texturey = (1.0f/16.0f)*6;
	 }
	 else if(character >= 'p' && character <= '~') {
	     character-='p';
		 texturex = (1.0f/16.0f)*character;
		 texturey = (1.0f/16.0f)*7;
	 }
	 
	 glBegin(GL_TRIANGLE_STRIP);
	 glTexCoord2f(texturex+(1.0f/16.0f), texturey+0.008f); glVertex2f(x+taillefont, y);//+0.008f pour ajuster les imprcision de calculs qui engendrent l'appartition de petits traits de la lettre au-dessus
	 glTexCoord2f(texturex+0.005f, texturey+0.008f); glVertex2f(x, y);
	 glTexCoord2f(texturex+(1.0f/16.0f), texturey+(1.0f/16.0f)); glVertex2f(x+taillefont, y+taillefont);
	 glTexCoord2f(texturex+0.005f, texturey+(1.0f/16.0f)); glVertex2f(x, y+taillefont);//+0.005f pour ajuster les imprcision de calculs qui engendrent l'appartition de petits traits de la lettre avant
	 glEnd();
}

void writeSDLImageFont(int texture, char*txt, float taillefont, float x, float y, int transparence, float indicetransparence) {
	 float ecartementletter = taillefont-(taillefont/6.0f);
	 glPushMatrix();
	 
	 if(transparence) {
	     glEnable(GL_ALPHA_TEST);
	 }
	 
	 glEnable(GL_TEXTURE_2D);
	 glBindTexture(GL_TEXTURE_2D, texture);
	 
	 if(transparence) {
	     glAlphaFunc(GL_GREATER, indicetransparence);
	 }
	 
	 while(*txt!='\0') {//tant qu'on est pas  la fin du tableau char *txt (ou s'il n'y a pas de problme) alors on applique:
	     if(*txt != '\n') {
		     writeSDLImageChar(*txt, taillefont, x, y);
		 }
		 else if(*txt == '\n') {
		     y+=taillefont;
			 x = -taillefont;//-taillefont car c'est pour enlever l'espace cre par '\n' :p
		 }
		 *txt++;//on parcours le tableau de char (on applique writeSDLIMGChar pour chaque caractre de la phrase *txt ainsi ;))
		 x+=ecartementletter;//pour faire l'cartement entre chaque lettre;
	 }
	 
	 if(transparence) {
	     glDisable(GL_ALPHA_TEST);
	 }
	 
	 glColor3f(1.0f, 1.0f, 1.0f);
	 glPopMatrix();
}
