#ifndef __FRUSTUM_H__
#define __FRUSTUM_H__

#include "../varglob.h"

typedef struct Frustum {
     float clipping[16];//16 valeur float pour la matrice de multiplication des matrice de projection et de modlisation
	 float modelview[16];
	 float projection[16];
	 float frustum[6][4];//6 car on va extraire 6 plans et 4 car chaque plan est dfini par 4 nombre (A, B, C les normales et D la distance  l'origine);
	 float normalisation;//pour normaliser les vecteur de frustrum (c'est -  - dire les rendre tous gal  1)
	 int plane;
}
Frustum;

void updateExtractPlaneFrustum(Frustum*frustum);
int pointInFrustum(float x, float y, float z, Frustum*frustum);
int sphereInFrustum(float x, float y, float z, float rayon, Frustum*frustum);
int cubeInFrustum(float x, float y, float z, float size, Frustum*frustum);

#endif
