#include "Texture.h"

int resizeTexture(int size) {//pour que la taillle de la texture soit une puissance de 2 ^^
     int resize = 1;//resize == 1bit
	 while(resize < size) { 
	     resize<<=1;//on place tous les bit  gauche tant que resize est < size ;)
	 }
	 return resize;//on retoune sa valeur :)
}

int loadSDLTexture(char*filename, int modeaffichagegl) {
     SDL_Surface*surface = NULL;
	 SDL_Surface*socletexture = NULL;
	 Uint32 rmask, bmask, gmask, amask;
	 GLint textures;
	 
	 surface = IMG_Load(filename);
	 
	 if(surface > 0) {
	     #if SDL_BYTEORDER == SDL_BIG_ENDIAN
		     rmask = 0xff000000;
			 gmask = 0x00ff0000;
			 bmask = 0x0000ff00;
			 amask = 0x000000ff;
		 #else 
		     rmask = 0x000000ff;
			 gmask = 0x0000ff00;
			 bmask = 0x00ff0000;
			 amask = 0xff000000;
		 #endif
		 
		 socletexture = SDL_CreateRGBSurface(SDL_SWSURFACE, resizeTexture(surface->w), resizeTexture(surface->h), 32, rmask, gmask, bmask, amask);//on cre la surface qui va recevoir notre image (==texture) qui sera utilis avec opengl (avec une profondeur de 32 bit)
		 
		 if(surface->flags == SDL_SRCALPHA) {//si le flags est un alpha alors on applique la transparence avec pour opacit 0
		     SDL_SetAlpha(surface, 0, SDL_ALPHA_TRANSPARENT);//avec SDL_ALPHA_TRANSPARENT = 0;
		 }
		 
		 SDL_BlitSurface(surface, NULL, socletexture, NULL);//on plaque l'image sur la surface que l'on vient de cre ;)
		 
		 glGenTextures(1, &textures);
		 glBindTexture(GL_TEXTURE_2D, textures);
		 if(modeaffichagegl == 0) {
		     glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, resizeTexture(surface->w), resizeTexture(surface->h), 0, GL_RGBA, GL_UNSIGNED_BYTE, socletexture->pixels);
		     glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		     glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		 }
		 else if(modeaffichagegl == 1) {
		     gluBuild2DMipmaps(GL_TEXTURE_2D, 4, resizeTexture(surface->w), resizeTexture(surface->h), GL_RGBA, GL_UNSIGNED_BYTE, socletexture->pixels);
			 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST);
			 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		 }
	 }
	 else {
	     return 0;
	 }
	 
	 SDL_FreeSurface(socletexture);
	 return textures;
}
